function [all_theta] = oneVsAll(X, y, num_labels, lambda)

%   ONEVSALL trains multiple logistic regression classifiers and returns all
%   the classifiers in a matrix all_theta, where the i-th row of all_theta 
%   corresponds to the classifier for label i
%   [all_theta] = ONEVSALL(X, y, num_labels, lambda) trains num_labels
%   logisitc regression classifiers and returns each of these classifiers
%   in a matrix all_theta, where the i-th row of all_theta corresponds 
%   to the classifier for label i

% ====================== YOUR CODE HERE ===================================
% Instructions: You should complete the following code to train num_labels
%               logistic regression classifiers with regularization
%               parameter lambda. 
%
%       fmincg works similarly to fminunc, but is more efficient when we
%       are dealing with large number of parameters.
% =========================================================================

[m , n] = size(X);
X = [ones(m, 1) X];

all_theta = zeros(num_labels, n + 1);
initial_theta = zeros(n + 1, 1);

options = optimset('GradObj', 'on', 'MaxIter', 50);

for k = 1:num_labels
    [all_theta(k,:)] = fmincg(@(t)(lrCostFunction(t, X, (y == k), lambda)), initial_theta, options);
end

end
