function p = predictOneVsAll(all_theta, X)

%   PREDICT Predict the label for a trained one-vs-all classifier.
%   The labels are in the range 1..K, where K = size(all_theta, 1). 
%   p = PREDICTONEVSALL(all_theta, X) will return a vector of predictions
%   for each example in the matrix X. Note that X contains the examples in
%   rows. all_theta is a matrix where the i-th row is a trained logistic
%   regression theta vector for the i-th class. 
%   You should set p to a vector of values from 1..K 
%   (e.g., p = [1; 3; 1; 2] predicts classes 1, 3, 1, 2 for 4 examples) 
%   Instructions: Complete the following code to make predictions using
%               your learned logistic regression parameters (one-vs-all).
%               You should set p to a vector of predictions (from 1 to num_labels).

X = [ones(size(X, 1), 1) X];

H_theta = sigmoid(all_theta*X'); % (num_labels,m)

[~ , p] = max(H_theta, [], 1);
p = p';

% m = size(X, 1);
% p = zeros(m,1);
% for k = 1:m
%     p(k) = find(H_theta(:,k) == max(H_theta(:,k)));
% end
